<?php

include('auth.php');
include ("jpgraph/jpgraph.php");
include ("jpgraph/jpgraph_line.php");


if (isset($schedule) ) {
    if(!is_numeric($schedule)) { JpGraphError::Raise(" Incorrect parameter. "); }
    $query="select count(id) from nessus_schedule where username='$username' and id=$schedule";
    $result=$dbconn->execute($query);
    list($allowaccess)=$result->fields;
    if ($allowaccess<>1) { JpGraphError::Raise(" Incorrect parameter. "); }
    $img.="&amp;schedule=$schedule";
    $msg2="$schedule";
}
if (isset($sid) ) {
    if(!is_numeric($sid)) { JpGraphError::Raise(" Incorrect parameter. "); }
    $query="select count(nessus_settings.id) from nessus_settings inner join nessus_settings_users on nessus_settings.id=nessus_settings_users.sid where nessus_settings_users.username='$username' and nessus_settings.id=$sid";
    $result=$dbconn->execute($query);
    list($allowaccess)=$result->fields;
    if ($allowaccess<>1) { JpGraphError::Raise(" Incorrect parameter. "); }
}
if (isset($days) ) {
    if(!is_numeric($days) or $days<0) { JpGraphError::Raise(" Incorrect parameter. "); }
}
if (isset($rrisk) ) {
    if(!is_numeric($rrisk)) { JpGraphError::Raise(" Incorrect parameter. "); }
    if($rrisk<1 or $rrisk>7) { JpGraphError::Raise(" Incorrect parameter. "); }
}
if (isset($ip) ) {
    $ip=htmlspecialchars($ip);
    $ip=mysql_escape_string($ip);
    include ('validateip.inc.php');
    if (!inrange($ip, $dbconn)) { JpGraphError::Raise(" Incorrect parameter. "); }
}


$datax=array();
$risk1=array();
$risk2=array();
$risk3=array();
$risk4=array();
$risk5=array();
$risk6=array();
$risk7=array();



$query = "select distinct scantime as vdate from nessus_results where username='$username'";


if (isset($days) ) {

    $query.=" and TO_DAYS(now())-TO_DAYS(scantime)<=$days";

}


if (isset($schedule) ) {

    $query.=" and sched_id=$schedule";

}

if (isset($ip) ) {

    $query.=" and host='$ip'";


}

if (isset($sid) ) {

    $query.=" and sid=$sid";

}

if (isset($rrisk) ) {

    $query.=" and risk=$rrisk";
}

$query.=" order by vdate";



$result=$dbconn->execute($query);

$totalrows=0;
while(!$result->EOF) {
    $totalrows = $totalrows + 1;
    list($date)=$result->fields;
    array_push($datax, $date);
    $prevrisk=0;

    $query1="select risk, count(scantime) as vcount  from nessus_results where scantime='$date' and username='$username' and falsepositive<>'Y' and scriptid <> 10180 and msg<>''";


    if (isset($schedule) ) {

        $query1.=" and sched_id=$schedule";

    }

    if (isset($ip) ) {

        $query1.=" and host='$ip'";


    }

    if (isset($sid) ) {

        $query1.=" and sid=$sid";

    }

    if (isset($rrisk) ) {

        $query1.=" and risk=$rrisk";
    }
    $query1.=" group by risk order by risk";


    $result1=$dbconn->execute($query1);

    while (list($risk, $riskcount)=$result1->fields) {

        for ($i=0;$i<$risk-$prevrisk-1;$i++) {

            switch ($i+$prevrisk+1) {
            case 1:
                    array_push($risk1,0);
                break;
            case 2:
                array_push($risk2,0);
                break;
            case 3:
                array_push($risk3,0);
                break;
            case 4:
                array_push($risk4,0);
                break;
            case 5:
                array_push($risk5,0);
                break;
            case 6:
                array_push($risk6,0);
                break;
            case 7:
                array_push($risk7,0);
                break;
            } #end of switch

        } #end of if
        switch ($risk) {
            case 1:
                array_push($risk1,$riskcount);
                break;
            case 2:
                array_push($risk2,$riskcount);
                break;
            case 3:
                array_push($risk3,$riskcount);
                break;
            case 4:
                array_push($risk4,$riskcount);
                break;
            case 5:
                array_push($risk5,$riskcount);
                break;
            case 6:
                array_push($risk6,$riskcount);
                break;
            case 7:
                array_push($risk7,$riskcount);
                break;
            } #end of switch


        $prevrisk=$risk;

    $result1->MoveNext();
    }

    for ($i=$prevrisk+1; $i<=7; $i++) {
        switch ($i) {
        case 1:
            array_push($risk1,0);
            break;
        case 2:
            array_push($risk2,0);
            break;
        case 3:
            array_push($risk3,0);
            break;
        case 4:
            array_push($risk4,0);
            break;
        case 5:
            array_push($risk5,0);
            break;
        case 6:
            array_push($risk6,0);
            break;
        case 7:
            array_push($risk7,0);
            break;
        } #end of switch




    }



$result->MoveNext();
} #End of while;
// Create the graph. These two calls are always required
// Setup the graph

$graph = new Graph(640,400,"auto");
$graph->SetScale("textlin");
$graph->SetShadow();
$graph->img->SetMargin(70,150,20,100);
$graph->SetMarginColor('white');

$graph->title->Set("$days Day(s) Vulnerability Trend");
$graph->title->SetFont(FF_FONT1,FS_BOLD,12);

$graph->xaxis->SetTickLabels($datax);
$graph->xaxis->SetFont(FF_FONT1,FS_NORMAL,8);
$graph->xaxis->SetLabelAngle(90);
$graph->xaxis->SetTextTickInterval(1);
#$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD,10);
#$graph->xaxis->title->Set("Dates");

$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD,10);
$graph->yaxis->title->Set("Vulnerabilities");


$graph->ygrid->SetFill(true,'#EFEFEF@1','#BBCCFF@0.5');
$graph->xgrid->Show();

//Line thickness for all lines
$linethick = 3;


// Create the first line
$p1 = new LinePlot($risk1);
$p1->SetColor("red");
$p1->SetLegend('Serious');
$p1->SetWeight($linethick);
$graph->Add($p1);

// Create the second line
$p2 = new LinePlot($risk2);
$p2->SetColor("yellow");
$p2->SetLegend('High');
$p2->SetWeight($linethick + 2);
$graph->Add($p2);

// Create the third line
$p3 = new LinePlot($risk3);
$p3->SetColor("magenta");
$p3->SetLegend('Medium');
$p3->SetWeight($linethick);

$graph->Add($p3);

// Create the third line
$p4 = new LinePlot($risk4);
$p4->SetColor("orange");
$p4->SetLegend('Medium/Low');
$p4->SetWeight($linethick);

$graph->Add($p4);


// Create the third line
$p5 = new LinePlot($risk5);
$p5->SetColor("navy");
$p5->SetLegend('Low/Medium');
$p5->SetWeight($linethick);
$graph->Add($p5);

// Create the third line
$p6 = new LinePlot($risk6);
$p6->SetColor("green");
$p6->SetLegend('Low');
$p6->SetWeight($linethick);
$graph->Add($p6);

// Create the third line
$p7 = new LinePlot($risk7);
$p7->SetColor("blue");
$p7->SetLegend('Info');
$p7->SetWeight($linethick);
$graph->Add($p7);

$graph->legend->SetShadow('gray@0.4',5);
$graph->legend->SetPos(0.04,0.06,'right','top');
$graph->legend->SetFont(FF_FONT1,FS_NORMAL,10);

// Display the graph
if ($totalrows > 1) {
    $graph->Stroke();
}
else {
    JpGraphError::Raise("Only 1 value returned - 2 or more values required to produce this graph.");
}

?>


