<?php
//
// $Id: respdf.php,v 1.4 2004/12/16 21:41:59 greg_k Exp $
//

/***********************************************************/
/* last update: 11.17.2004                                 */
/* --------------------------------------------------------*/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2002 Inprotect.com                        */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* Alex Zimin (alex@inprotect.com)                         */
/* http://www.inprotect.com                                */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);
include ('auth.php');

if (!is_numeric($schedid)) {die("Can not access this page");}
$query="select count(id) from nessus_schedule where username='$username' and id=$schedid";
$result=$dbconn->execute($query);

list($allowaccess)=$result->fields;
if ($allowaccess<>1) {die("Can not access this page");}


$scantime=htmlspecialchars($scantime);
$scantime=mysql_escape_string($scantime);

//Seperates the parts of the date so it doesn't just display it as one big number
$scanyear = substr($scantime, 0, 4);
$scanmonth = substr($scantime, 4, 2);
$scanday = substr($scantime, 6, 2);
$scanhour = substr($scantime, 8, 2);
$scanmin = substr($scantime, 10, 2);
$scansec = substr($scantime, 12);

//Generated date
$gendate = date("m/j/Y H:i:s");

//here you can set the preference for the table colors
$head_fill_color = array(100,149,237);
$head_text_color = 255;
$fill_color = array(224,235,255);
$text_color = 0;
$line_color = array(0,0,0);
$boarder_type = 1; #doesn't work yet, there's always a full boarder for now

//row height for the table
$row_height = 5;


$query="select count(scantime) from nessus_results
       where scantime='$scantime' and username='$username' and sched_id=$schedid";
$result=$dbconn->execute($query);

list($allowaccess)=$result->fields;
if ($allowaccess<1) {die("Can not access this page");}

//include pdf libraries
define('FPDF_FONTPATH','inc/font/');
require('inc/InproTable.php');

set_time_limit(300);
//start pdf file, add page, set font
$pdf = new PDF();
$pdf->AddPage();
$pdf->SetFont('Helvetica', 'B', 15);
$pdf->Cell(0, 9, 'Inprotect Vulnerability Report', 1, 1, 'C', 0);

$pdf->SetFont('Helvetica', '', 10);

#$pdf->Cell(0,6,"Scan time: $scanmonth/$scanday/$scanyear $scanhour:$scanmin:$scansec     Generated: $gendate", 1, 1, 'C', 0);
$pdf->Cell(95,6,"Scan time: $scanmonth/$scanday/$scanyear $scanhour:$scanmin:$scansec",1,0,'C');
$pdf->Cell(95,6,"Generated: $gendate",1,0,'C');
$pdf->Ln();

if ($scantime<>"" and $scantype=="A" and $schedid<>"") {
    $pdf->SetFont('Helvetica', '', 10);

    //get current possition so we can put the pie chart to the side
    $valX = $pdf->GetX();
    $valY = $pdf->GetY();
    $riskarray = array(); //array of risks for pie chart
    $colorarray=array(); //array of colors for pie chart

    $result=$dbconn->Execute("SELECT DISTINCT host FROM `nessus_results`
        where scantime='$scantime' and username='$username' and scantype='$scantype' and sched_id=$schedid order BY host");

    //initialise variable for number of hosts while loop
    $i = 0;
    while ($host=$result->fields) {
        $IPS[$i] = $host[0];
        $i++;
        $result->MoveNext();
    }

    $result=$dbconn->Execute("SELECT count(risk) as count, risk FROM `nessus_results`
        where scantime='$scantime' and username='$username' and scantype='$scantype' and sched_id=$schedid group by risk");
    $index = 0;

    $pdf->Ln();
    $pdf->SetFont('Helvetica', 'B', 10);
    $pdf->Cell(0, 6, "Total number of vulnerabilities identified on " .sizeof($IPS). " system(s)",0,1,'C');
    $pdf->Rect(10,31,190,48);
    $pdf->Ln();
    $pdf->SetFont('Helvetica', '', 10);
		#$pdf->Rect(100, 200, 130, 140, DF);
    while (list($riskcount, $risk)=$result->fields) {

        $pdf->MultiCell(70, 6, "".getrisk($risk)." : $riskcount" ,0,0,'C');
        $riskArray [getrisk($risk)] = $riskcount;
        $colorarray[$index] = getriskcolor($risk);
        $index++;
		#$pdf->Ln();
        $result->MoveNext();
    }

    //make pie chart and put current possition below

    $pdf->Ln();


    $pdf->SetXY(85, 38); #$valY);
    $pdf->PieChart(140, 40, $riskArray, '%l', $colorarray);
    $pdf->SetXY($valX, $valY + 40);


    //Host-Vulnerability Summary
    $pdf->Ln();
    $pdf->Ln();
    $pdf->Ln();
    $pdf->Ln();
    $pdf->SetFont('Helvetica', 'B', 10);
    $size= 12 + (6 * sizeof($IPS));
    $pdf->Rect(10,85,190,$size);
    $pdf->Cell(0, 6, "Total number of vulnerabilities identified per system",0,1,'C');
    $pdf->SetFont('Helvetica', '', 10);
    $pdf->Cell(36, 6, "Host",1,0,'C');
    $pdf->Cell(22, 6, "Serious",1,0,'C');
    $pdf->Cell(22, 6, "High",1,0,'C');
    $pdf->Cell(22, 6, "Medium",1,0,'C');
    $pdf->Cell(22, 6, "Medium/Low",1,0,'C');
    $pdf->Cell(22, 6, "Low/Medium",1,0,'C');
    $pdf->Cell(22, 6, "Low",1,0,'C');
    $pdf->Cell(22, 6, "Info",1,0,'C');

    $pdf->Ln();

    $j = 0;
    for($j=0; $j<$i; $j++)
{
    $pdf->Cell(36, 6, $IPS[$j],1,0,'C');

        $result1=$dbconn->Execute("SELECT count(risk) as count, risk FROM `nessus_results`
	    where scantime='$scantime' and username='$username' and scantype='$scantype'
	    and sched_id=$schedid and host='$IPS[$j]' and falsepositive <> 'Y' group by risk");

        $prevrisk=0;
        while(list($riskcount, $risk)=$result1->fields) {

            for ($k=0;$k<$risk-$prevrisk-1;$k++) {
                $pdf->Cell(22, 6, "--" ,1,0,'C');
            }

            $pdf->Cell(22, 6, "$riskcount" ,1,0,'C');
            $prevrisk=$risk;
            $result1->MoveNext();
        }

        $pdf->Ln();

    }

    $pdf->Ln();

    //build array of risks
    $pdf->SetFont('Helvetica', '', 10);
    $result=$dbconn->Execute("select distinct host, service, risk, msg from nessus_results
        where scantime='$scantime' and scantype='$scantype' and username='$username'
	and sched_id=$schedid order by host ASC, risk ASC");


    while ($row = $result->FetchRow()){
        $row[2]=getrisk($row[2]);
        $row[3]=trim($row[3]);
        $all_results[] = $row;
    }

    //Vulnerability table configs
    $cols = array('Host','Service','Risk','Description');

    //widths for columns
    $width_array=array(30,40,15,105);

    //build table
    $pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);

    $pdf->Ln();
    $pdf->Cell(0,6, 'Inprotect.com - web interface for Nessus and Nmap scanners',0, 1, 'C', 0);


} #$pdf->Image('/var/www/html/images/Picture2.png',50,90,0,0,$type='',$link='');

//output the pdf, now we're done$pdf-
$pdf->Output();

//matches risks numbers with names
function getrisk($risk) {

    switch ($risk) {
    case 1:
            $risk="Serious";
        break;
    case 2:
        $risk="High";
        break;
    case 3:
        $risk="Medium";
        break;
    case 4:
        $risk="Medium/Low";
        break;
    case 5:
        $risk="Low/Medium";
        break;
    case 6:
        $risk="Low";
        break;
    case 7:
        $risk="Info";
        break;
    }

    return $risk;
}

//matches risks number with colors
function getriskcolor($risk)
{
    switch ($risk)
    {
    case 1:
        $risk=array(255,0,0);
        break;
    case 2:
        $risk=array(255,0,0);
        break;
    case 3:
        $risk=array(255,255,0);
        break;
    case 4:
        $risk=array(255,255,0);
        break;
    case 5:
        $risk=array(255,255,0);
        break;
    case 6:
        $risk=array(0,139,69);
        break;
    case 7:
        $risk=array(100,149,237);
        break;
    }
    return $risk;
}
?>
